/*****************************************
*  xv Ver3
*   \
*    HS-15POPAMP2AN5
*    1kHzZTΐgAN5
*    xZTOPAMP1AN4
*****************************************/
#include  <16f785.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,PUT,BROWNOUT,MCLR,NOIESO,NOFCMEN
#device ADC=10

#use delay(CLOCK = 8000000)
#use FAST_IO(A)
#use FAST_IO(B)
#use FAST_IO(C)

#BYTE OPA1CON = 0x11C
#BYTE OPA2CON = 0x11D

/**** t\pݒ *****/
#define DB7 PIN_C4
#define DB6 PIN_C5
#define DB5 PIN_A4
#define DB4 PIN_A5
#define RS  PIN_A2
#define STB PIN_A0
#include <lcd_lib.c>
/*** ϐ̒` ***/
int Flag, Level, Index, i;
char StMsg[] = "Start!";
float Humi[5], Temp[5], sTemp, sHumi;
long data;

/*****************************************
* ^C}2̊荞ݏ
* 100usecŊ荞
* ߎg̏ó@0.2V1.25VԂ5
*****************************************/
#int_timer2
void Intval(void)
{
        switch(Level)  // xƂɓdo
        {
                case 1: setup_vref(VREF_OUT_CVREF | VREF_C1_LOW | 1);
                                break;
                case 2:         setup_vref(VREF_OUT_CVREF | VREF_C1_LOW | 2);
                                break;
                case 3:         setup_vref(VREF_OUT_CVREF | VREF_C1_LOW | 3);
                                break;
                case 4: setup_vref(VREF_OUT_CVREF | VREF_C1_LOW | 4);
                                break;
                case 5:         setup_vref(VREF_OUT_CVREF | VREF_C1_LOW | 5);
                                break;
                case 6:         setup_vref(VREF_OUT_CVREF | VREF_C1_LOW | 6);
                                break;
                default:        break;
        } 
        if(Flag)        {       // ㏸H
                Level++;                                // xAbv
                if(Level >= 7){         // 7܂ł牺~ɂ
                        Flag = 0;
                        Level = 5;              // ŏ̉~5
                }
        }
        else{           // ~̏ꍇ
                Level--;                                // x_E
                if(Level < 1)   {               // 0܂ł㏸ɂ
                        Flag = 1;               // ㏸w
                        Level = 2;              // ŏ̏㏸1
                }
        }
}

/*********** C֐ **************/
void main(void)
{
        // I/OAW[ݒ
        set_tris_A(0x08);                                               // LCDp
        set_tris_B(0x30);                                               // A/D
        set_tris_C(0xCF);                                               // Av֌W
        output_c(0);                                                    // 
        OPA1CON = 0x80;                                         // IyAvgpݒ
        OPA2CON = 0x80;
        setup_timer_2(T2_DIV_BY_1 0xC7, 1);             // Timer2 ݒ 100usec
        setup_adc(ADC_CLOCK_DIV_16);                    // A/D ݒ
        setup_adc_ports(sAN5 | sAN4);
        // p[^
        Flag = 1;
        Level = 1;
        Index = 0;
        for(i=0; i<5; i++){                                     // obt@
                Temp[i] = 0;    
                Humi[i] = 0;
        }
        // JnbZ[WLCD\
        lcd_init();                                                     // LCD
        lcd_clear();
        lcd_str(StMsg);
        delay_ms(500);                                          // 0.5bԕ\
        enable_interrupts(INT_TIMER2);                  // 荞݋
        enable_interrupts(GLOBAL);
        /********* C[v *************/
        while(1)
        {
                /*** x ****/
                set_adc_channel(4);                             // AN4w
                delay_us(50);                                           // 50usec҂
                data = read_adc();                              // A/D
                // x̃XP[ϊ@T=50.0*X/1024
                Temp[Index] = (48.0 * data)/1024;       // xɕϊAobt@Ɋi[
                /*** x  *****/
                set_adc_channel(5);                             // AN5 xI
                delay_us(50);                                           // 50usec       
                data = read_adc() - 230;                        // xǂݍ
                // xXP[ϊ
                Humi[Index] = 0.755 * data - 43;        // XP[ϊAobt@i[
                Index++;                                                        // obt@CfbNXXV
                if(Index == 5)
                        Index = 0;
                // ړόvZ
                sTemp = 0;
                sHumi = 0;
                for(i=0; i<5; i++)              {
                        sTemp = sTemp + Temp[i];                // 5񕪕
                        sHumi = sHumi + Humi[i];
                }
                // \     
                lcd_cmd(0x80);                                  // 1s
                printf(lcd_data, "Temp= %2.1f Deg/C", sTemp/5);
                lcd_cmd(0xC0);                                  // 2s
                printf(lcd_data, "Hum =%3.0f   %%RH  ", sHumi/5);
                delay_ms(1000);                                 // JԂ@1b    
        }
}